Module javafx.base
Package javafx.beans.property

# Class LongPropertyBase

java.lang.Object
javafx.beans.binding.NumberExpressionBase
javafx.beans.binding.LongExpression
javafx.beans.property.ReadOnlyLongProperty
javafx.beans.property.LongProperty
javafx.beans.property.LongPropertyBase

All Implemented Interfaces:
  `NumberExpression`, `Observable`, `Property<Number>`, `ReadOnlyProperty<Number>`, `ObservableLongValue`, `ObservableNumberValue`, `ObservableValue<Number>`, `WritableLongValue`, `WritableNumberValue`, `WritableValue<Number>`

Direct Known Subclasses:
  `SimpleLongProperty`, `StyleableLongProperty`

public abstract class LongPropertyBase extends LongProperty
The class `LongPropertyBase` is the base class for a property wrapping a `long` value. It provides all the functionality required for a property except for the `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()` methods, which must be implemented by extending classes.

Since:
  JavaFX 2.0
See Also:
  - `LongProperty`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LongPropertyBase()`
  The constructor of the `LongPropertyBase`.
  `LongPropertyBase(long initialValue)`
  The constructor of the `LongPropertyBase`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super Number> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `bind(ObservableValue<? extends Number> rawObservable)`
  Create a unidirection binding for this `Property`.
  `protected void`
  `fireValueChangedEvent()`
  Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`.
  `long`
  `get()`
  Get the wrapped value.
  `protected void`
  `invalidated()`
  The method `invalidated()` can be overridden to receive invalidation notifications.
  `boolean`
  `isBound()`
  Can be used to check, if a `Property` is bound.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super Number> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `set(long newValue)`
  Set the wrapped value.
  `String`
  `toString()`
  Returns a string representation of this `LongPropertyBase` object.
  `void`
  `unbind()`
  Remove the unidirectional binding for this `Property`.

  ### Methods declared in class javafx.beans.property.LongProperty

  `asObject, bindBidirectional, longProperty, setValue, unbindBidirectional`

  ### Methods declared in class javafx.beans.property.ReadOnlyLongProperty

  `readOnlyLongProperty`

  ### Methods declared in class javafx.beans.binding.LongExpression

  `add, add, add, add, divide, divide, divide, divide, doubleValue, floatValue, getValue, intValue, longExpression, longExpression, longValue, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract`

  ### Methods declared in class javafx.beans.binding.NumberExpressionBase

  `add, asString, asString, asString, divide, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, multiply, numberExpression, subtract`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `getValue`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface javafx.beans.value.WritableValue

  `getValue`

- ## Constructor Details

  - ### LongPropertyBase

    public LongPropertyBase()
    The constructor of the `LongPropertyBase`.

  - ### LongPropertyBase

    public LongPropertyBase(long initialValue)
    The constructor of the `LongPropertyBase`.
    Parameters:
      `initialValue` - the initial value of the wrapped value

- ## Method Details

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super Number> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super Number> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### fireValueChangedEvent

    protected void fireValueChangedEvent()
    Sends notifications to all attached `InvalidationListeners` and `ChangeListeners`. This method is called when the value is changed, either manually by calling `set(long)` or in case of a bound property, if the binding becomes invalid.

  - ### invalidated

    protected void invalidated()
    The method `invalidated()` can be overridden to receive invalidation notifications. This is the preferred option in `Objects` defining the property, because it requires less memory. The default implementation is empty.

  - ### get

    public long get()
    Get the wrapped value. Unlike `WritableValue.getValue()`, this method returns primitive long. Needs to be identical to `WritableValue.getValue()`.
    Returns:
      The current value

  - ### set

    public void set(long newValue)
    Set the wrapped value. Unlike `WritableLongValue.setValue(java.lang.Number)`, this method uses primitive long.
    Parameters:
      `newValue` - The new value

  - ### isBound

    public boolean isBound()
    Can be used to check, if a `Property` is bound.
    Returns:
      `true` if the `Property` is bound, `false` otherwise
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### bind

    public void bind(ObservableValue<? extends Number> rawObservable)
    Create a unidirection binding for this `Property`.

    Note that JavaFX has all the bind calls implemented through weak listeners. This means the bound property can be garbage collected and stopped from being updated.

    Parameters:
      `rawObservable` - The observable this `Property` should be bound to.

  - ### unbind

    public void unbind()
    Remove the unidirectional binding for this `Property`. If the `Property` is not bound, calling this method has no effect.
    See Also:
      - `Property.bind(javafx.beans.value.ObservableValue)`

  - ### toString

    public String toString()
    Returns a string representation of this `LongPropertyBase` object.
    Overrides:
      `toString` in class `LongProperty`
    Returns:
      a string representation of this `LongPropertyBase` object.